From bdbd555a7fed6e084a454d64ba0b98aac1d85241 Mon Sep 17 00:00:00 2001
From: Johnson Chu <johnsoncodehk@gmail.com>
Date: Sun, 8 Dec 2024 19:28:06 +0800
Subject: [PATCH 02/10] fix(typescript): should not suppressing getLanguageId
 crashes

close #253
---
 .../createAsyncLanguageServicePlugin.ts         | 17 ++++++++++-------
 .../quickstart/createLanguageServicePlugin.ts   | 17 ++++++++++-------
 2 files changed, 20 insertions(+), 14 deletions(-)

diff --git a/packages/typescript/lib/quickstart/createAsyncLanguageServicePlugin.ts b/packages/typescript/lib/quickstart/createAsyncLanguageServicePlugin.ts
index ecad5679..a4c42c10 100644
--- a/packages/typescript/lib/quickstart/createAsyncLanguageServicePlugin.ts
+++ b/packages/typescript/lib/quickstart/createAsyncLanguageServicePlugin.ts
@@ -82,20 +82,23 @@ export function createAsyncLanguageServicePlugin(
 							],
 							new FileMap(ts.sys.useCaseSensitiveFileNames),
 							fileName => {
+								let snapshot: ts.IScriptSnapshot | undefined;
+
 								try { // getSnapshot could be crashed if the file is too large
-									let snapshot = info.project.getScriptInfo(fileName)?.getSnapshot();
+									snapshot = info.project.getScriptInfo(fileName)?.getSnapshot();
 									if (!snapshot) {
 										// trigger projectService.getOrCreateScriptInfoNotOpenedByClient
 										info.project.getScriptVersion(fileName);
 										snapshot = info.project.getScriptInfo(fileName)?.getSnapshot();
 									}
-									if (snapshot) {
-										language.scripts.set(fileName, snapshot);
-									}
-									else {
-										language.scripts.delete(fileName);
-									}
 								} catch { }
+
+								if (snapshot) {
+									language.scripts.set(fileName, snapshot);
+								}
+								else {
+									language.scripts.delete(fileName);
+								}
 							}
 						);
 
diff --git a/packages/typescript/lib/quickstart/createLanguageServicePlugin.ts b/packages/typescript/lib/quickstart/createLanguageServicePlugin.ts
index f03447b6..b4eef62a 100644
--- a/packages/typescript/lib/quickstart/createLanguageServicePlugin.ts
+++ b/packages/typescript/lib/quickstart/createLanguageServicePlugin.ts
@@ -41,20 +41,23 @@ export function createLanguageServicePlugin(
 						],
 						new FileMap(ts.sys.useCaseSensitiveFileNames),
 						fileName => {
+							let snapshot: ts.IScriptSnapshot | undefined;
+
 							try { // getSnapshot could be crashed if the file is too large
-								let snapshot = info.project.getScriptInfo(fileName)?.getSnapshot();
+								snapshot = info.project.getScriptInfo(fileName)?.getSnapshot();
 								if (!snapshot) {
 									// trigger projectService.getOrCreateScriptInfoNotOpenedByClient
 									info.project.getScriptVersion(fileName);
 									snapshot = info.project.getScriptInfo(fileName)?.getSnapshot();
 								}
-								if (snapshot) {
-									language.scripts.set(fileName, snapshot);
-								}
-								else {
-									language.scripts.delete(fileName);
-								}
 							} catch { }
+
+							if (snapshot) {
+								language.scripts.set(fileName, snapshot);
+							}
+							else {
+								language.scripts.delete(fileName);
+							}
 						}
 					);
 

